SystemOrganization addCategory: #'EyeTracker-FFI'!
SystemOrganization addCategory: #'EyeTracker-Core'!

Object subclass: #EyeTracker
	instanceVariableNames: 'isConnected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeTracker-Core'!

!EyeTracker methodsFor: 'connection' stamp: 'sgb 8/31/2015 16:07'!
connect
	self isConnected ifTrue: [^ self].
	EyeTrackerApi apiInitEyeTracker.
	isConnected:=true.
	
! !

!EyeTracker methodsFor: 'connection' stamp: 'sgb 8/31/2015 16:08'!
disconnect
self isConnected ifFalse: [^ self].
isConnected:=false.! !

!EyeTracker methodsFor: 'data adquisition' stamp: 'sgb 8/31/2015 16:11'!
giveMeTheData
 	^ self isConnected
		ifTrue: [EyeTrackerApi apiGiveMeTheData]
		ifFalse: [EyeXData nil]! !

!EyeTracker methodsFor: 'initialization' stamp: 'sgb 8/31/2015 16:08'!
initialize 
	isConnected :=false.

! !

!EyeTracker methodsFor: 'connection' stamp: 'sgb 8/31/2015 16:08'!
isConnected
	^ isConnected 

! !

Object subclass: #EyeTrackerApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeTracker-FFI'!

!EyeTrackerApi class methodsFor: 'primitives' stamp: 'sgb 8/31/2015 14:58'!
apiDisconnectEyeTracker
	<apicall: long 'disconnectEyeTracker' () module: 'EyeTracker.dll'>
	^ self externalCallFailed! !

!EyeTrackerApi class methodsFor: 'primitives' stamp: ''!
apiFoo
	<apicall: long 'foo' () module: 'EyeTracker.dll'>
	^ self externalCallFailed! !

!EyeTrackerApi class methodsFor: 'primitives' stamp: 'sgb 8/31/2015 15:08'!
apiGiveMeTheData
	<apicall: EyeXData 'giveMeTheData' () module: 'EyeTracker.dll'>
	^ self externalCallFailed! !

!EyeTrackerApi class methodsFor: 'primitives' stamp: 'sgb 8/31/2015 14:56'!
apiInitEyeTracker
	<apicall: long 'initEyeTracker' () module: 'EyeTracker.dll'>
	^ self externalCallFailed! !

ExternalStructure subclass: #EyeXData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeTracker-FFI'!

EyeXData class
	instanceVariableNames: 'nilInstance'!

EyeXData class
	instanceVariableNames: 'nilInstance'!

!EyeXData class methodsFor: 'as yet unclassified' stamp: 'sgb 8/31/2015 15:30'!
fields

"
	self defineFields.
"
	^ #(
	(gazeX 'float')
	(gazeY 'float')

	(leftEyePositionX 'float')
	(leftNormalizedEyePositionX 'float')
	(leftEyePositionY 'float')
	(leftNormalizedEyePositionY 'float')
	(leftEyePositionZ 'float')
	(leftNormalizedEyePositionZ 'float')

	(rightEyePositionX 'float')
	(rightNormalizedEyePositionX 'float')
	(rightEyePositionY 'float')
	(rightNormalizedEyePositionY 'float')
	(rightEyePositionZ 'float')
	(rightNormalizedEyePositionZ 'float')

	(connectionState 'long')
	
	(gazeTimeStamp 'float')
	(displaySizeWidth 'float')
	(displaySizeHeight 'float')
	(screenBoundsWidth 'float')
	(screenBoundsHeight 'float')

	)
        






! !

!EyeXData class methodsFor: 'as yet unclassified' stamp: 'sgb 8/31/2015 15:11'!
nil
	^ nilInstance ifNil: [nilInstance := self new]! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
connectionState
	"This method was automatically generated"
	^handle signedLongAt: 57! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
displaySizeHeight
	"This method was automatically generated"
	^handle floatAt: 69! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
displaySizeWidth
	"This method was automatically generated"
	^handle floatAt: 65! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
gazeTimeStamp
	"This method was automatically generated"
	^handle floatAt: 61! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
gazeX
	"This method was automatically generated"
	^handle floatAt: 1! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
gazeY
	"This method was automatically generated"
	^handle floatAt: 5! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
leftEyePositionX
	"This method was automatically generated"
	^handle floatAt: 9! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
leftEyePositionY
	"This method was automatically generated"
	^handle floatAt: 17! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
leftEyePositionZ
	"This method was automatically generated"
	^handle floatAt: 25! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
leftNormalizedEyePositionX
	"This method was automatically generated"
	^handle floatAt: 13! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
leftNormalizedEyePositionY
	"This method was automatically generated"
	^handle floatAt: 21! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
leftNormalizedEyePositionZ
	"This method was automatically generated"
	^handle floatAt: 29! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
rightEyePositionX
	"This method was automatically generated"
	^handle floatAt: 33! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
rightEyePositionY
	"This method was automatically generated"
	^handle floatAt: 41! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
rightEyePositionZ
	"This method was automatically generated"
	^handle floatAt: 49! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
rightNormalizedEyePositionX
	"This method was automatically generated"
	^handle floatAt: 37! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
rightNormalizedEyePositionY
	"This method was automatically generated"
	^handle floatAt: 45! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
rightNormalizedEyePositionZ
	"This method was automatically generated"
	^handle floatAt: 53! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
screenBoundsHeight
	"This method was automatically generated"
	^handle floatAt: 77! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 15:30'!
screenBoundsWidth
	"This method was automatically generated"
	^handle floatAt: 73! !
